﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.IO;
using System.Windows;

namespace WpfNotifyIconTest
{
    class TaskTray
    {
        private System.ComponentModel.IContainer components = null;

        private System.Windows.Forms.NotifyIcon SysTrayIcon;
        private System.Windows.Forms.ContextMenuStrip MainMenu;
        private System.Windows.Forms.ToolStripMenuItem configToolStripMenuItem;
        private System.Windows.Forms.ToolStripMenuItem exitToolStripMenuItem;

        public TaskTray()
        {
            InitializeComponent();

            HookEvents();
        }

        public void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.SysTrayIcon = new System.Windows.Forms.NotifyIcon(this.components);
            this.MainMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.configToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exitToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.MainMenu.SuspendLayout();

            this.SysTrayIcon.ContextMenuStrip = this.MainMenu;
            this.SysTrayIcon.Icon = new System.Drawing.Icon(this.GetType(), "myapp.ico");
            this.SysTrayIcon.Text = "MyApp";
            this.SysTrayIcon.Visible = true;

            BuildMenu();

            this.MainMenu.ResumeLayout(false);
        }

        private void BuildMenu()
        {
            this.MainMenu.Name = "MainMenu";
            this.MainMenu.Size = new System.Drawing.Size(114, 82);

            this.MainMenu.Items.Clear();

            this.configToolStripMenuItem.Size = new System.Drawing.Size(113, 22);
            this.configToolStripMenuItem.Text = "&Configuration";
            this.MainMenu.Items.Add(configToolStripMenuItem);

            this.MainMenu.Items.Add(new System.Windows.Forms.ToolStripSeparator());

            this.exitToolStripMenuItem.Name = "exitToolStripMenuItem";
            this.exitToolStripMenuItem.Size = new System.Drawing.Size(113, 22);
            this.exitToolStripMenuItem.Text = "E&xit";
            this.MainMenu.Items.Add(this.exitToolStripMenuItem);
        }

        private void HookEvents()
        {
            this.exitToolStripMenuItem.Click += (s, e) => { Application.Current.Shutdown(); };
            this.configToolStripMenuItem.Click += (s, e) =>
            {
                ShowConfig();
            };
        }

        private void ShowConfig()
        {
            Window1 window1 = new Window1();
            window1.ShowDialog();
        }
    }
}
